#include "GraphCtrl.h"

namespace Upp {
namespace GraphDraw_ns {

#define MAKE_STYLE_METH(STYLETYPE, STYLENAME)\
STYLETYPE Make__##STYLENAME##___##STYLETYPE();\
const STYLETYPE& STYLETYPE::STYLENAME() {\
	static const STYLETYPE s = Make__##STYLENAME##___##STYLETYPE(); \
	return s;\
}\
STYLETYPE Make__##STYLENAME##___##STYLETYPE()


MAKE_STYLE_METH( StdGridAxisDrawECtrl_GEStyle, StyleGEDefault) {
	StdGridAxisDrawECtrl_GEStyle s;
	
	const GridAxisDraw::StyleGE& gad  = GridAxisDraw::StyleGEDefault();

	// GED - GraphElementDraw
	s.lmntBackgnd           =  gad.lmntBackgnd;
	s.axisWidth             =  gad.axisWidth;
	s.axisColor             =  gad.axisColor;
	s.axisTextFont          =  gad.axisTextFont;
	s.axisTextColor         =  gad.axisTextColor;
	s.axisTickColor         =  gad.axisTickColor;
	s.gridColor             =  gad.gridColor;
	s.primaryTickFactory    =  gad.primaryTickFactory;
	s.secondaryTickFactory  =  gad.secondaryTickFactory;
	s.primaryTickFactory    =  gad.primaryTickFactory;
	s.secondaryTickFactory  =  gad.secondaryTickFactory;

	// GEC - GraphElementCtrl
	s.vSelectStyle     = GraphCtrlImg::VSELECT();
	s.vAxisSelectStyle = GraphCtrlImg::VAXISSELECT();
	s.hSelectStyle     = GraphCtrlImg::HSELECT();
	s.hAxisSelectStyle = GraphCtrlImg::HAXISSELECT();
	return s;
}

MAKE_STYLE_METH( StdGridAxisDrawECtrl_GEStyle, StyleGEDefault2) {
	StdGridAxisDrawECtrl_GEStyle s;

	const GridAxisDraw::StyleGE& gad  = GridAxisDraw::StyleGEDefault2();

	// GED - GraphElementDraw
	s.lmntBackgnd           =  gad.lmntBackgnd;
	s.axisWidth             =  gad.axisWidth;
	s.axisColor             =  gad.axisColor;
	s.axisTextFont          =  gad.axisTextFont;
	s.axisTextColor         =  gad.axisTextColor;
	s.axisTickColor         =  gad.axisTickColor;
	s.gridColor             =  gad.gridColor;
	s.primaryTickFactory    =  gad.primaryTickFactory;
	s.secondaryTickFactory  =  gad.secondaryTickFactory;
	s.primaryTickFactory    =  gad.primaryTickFactory;
	s.secondaryTickFactory  =  gad.secondaryTickFactory;

	// GEC - GraphElementCtrl
	s.vSelectStyle     = GraphCtrlImg::VSELECT();
	s.vAxisSelectStyle = GraphCtrlImg::VAXISSELECT();
	s.hSelectStyle     = GraphCtrlImg::HSELECT();
	s.hAxisSelectStyle = GraphCtrlImg::HAXISSELECT();
	return s;
}

}; // namespace GraphDraw_ns
}; // namespace Upp
